using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            int brojPokusaja, potrebanBrojZaZamenu, brojac=0, ponavljujucaVrednost=0;
            string[] s = new string[2];
            s = Console.ReadLine().Split(' ');
            brojPokusaja=Convert.ToInt32(s[0]);potrebanBrojZaZamenu = Convert.ToInt32(s[1]);
            int[] pokusaji = new int[brojPokusaja];
            s = new string[brojPokusaja];
            s = Console.ReadLine().Split(' ');
            for (int i = 0; i < brojPokusaja; i++)
            {
                pokusaji[i] = Convert.ToInt32(s[i]);
            }
            Array.Sort(pokusaji);
            for (int i = 0; i < brojPokusaja; i++)
            {
                if (ponavljujucaVrednost!=pokusaji[i])
                {
                    if (brojac >= potrebanBrojZaZamenu) Console.Write(ponavljujucaVrednost+" ");
                    ponavljujucaVrednost = pokusaji[i];
                    brojac = 0;
                }
                brojac++;
            }
            if (brojac >= potrebanBrojZaZamenu) Console.Write(ponavljujucaVrednost + " ");
            Console.WriteLine();
        }
    }
}